# This file was generated by running 'miaxml2nipype.py /build/mia-Mp5fYQ/mia-2.2.5/obj-x86_64-linux-gnu/doc/mia-2dstack-cmeans-presegment.xml /build/mia-Mp5fYQ/mia-2.2.5/obj-x86_64-linux-gnu/src/mia_2dstack_cmeans_presegment.py'
# '/build/mia-Mp5fYQ/mia-2.2.5/obj-x86_64-linux-gnu/src/mia_2dstack_cmeans_presegment.py' can be created by running 'mia-2dstack-cmeans-presegment --help-xml >/build/mia-Mp5fYQ/mia-2.2.5/obj-x86_64-linux-gnu/src/mia_2dstack_cmeans_presegment.py'

from nipype.interfaces.base import (
        TraitedSpec,
        CommandLineInputSpec,
        CommandLine,
        File,
        traits
    )
import os
#
# Input specification
#
class mia_2dstack_cmeans_presegment_InputSpec(CommandLineInputSpec):
	in_file = traits.File( desc="""input image(s) to be filtered""", argstr="--in-file %s", exists=True , mandatory = True )
	type = traits.String( desc="""output file name type""", argstr="--type %s" )
	verbose = traits.Enum("info", "trace", "fail", "warning", "error", "debug", "message", "fatal",  desc="""verbosity of output, print messages of given level and higher priorities. Supported priorities starting at lowest level are:""", argstr="--verbose %s" )
	histogram_thresh = traits.Float( desc="""Percent of the extrem parts of the histogram to be collapsed into the respective last histogram bin.""", argstr="--histogram-thresh %f" )
	classes = traits.String( desc="""C-means class initializerC-means class initializer""", argstr="--classes %s" )
	seed_threshold = traits.Float( desc="""Probability threshold value to consider a pixel as seed pixel.""", argstr="--seed-threshold %f" )
	flow_prob_thresh = traits.Float( desc="""Class probability threshold to cut the flow to zero for the source/sink flow connectivity creation""", argstr="--flow-prob-thresh %f" )
	flow_scale = traits.Float( desc="""Scaling factor to adjust the flow evaluated from the initial c-means segmentation.""", argstr="--flow-scale %f" )
	threads = traits.Int( desc="""Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).""", argstr="--threads %d" )
	out_probmap = File(desc="Save probability map to this file", argstr="--out-probmap %s" )
	out_labels = File(desc="output file name base", argstr="--out-labels %s" , mandatory = True )
	out_flow = File(desc="prefix for flow initialization images", argstr="--out-flow %s" )

#
# Output specification
#
class mia_2dstack_cmeans_presegment_OutputSpec(TraitedSpec):
	out_probmap = File(desc="Save probability map to this file")
	out_labels = File(desc="output file name base", exists = True )
	out_flow = File(desc="prefix for flow initialization images")


#
# Task class specification
#
class mia_2dstack_cmeans_presegment(CommandLine):
	input_spec = mia_2dstack_cmeans_presegment_InputSpec
	output_spec = mia_2dstack_cmeans_presegment_OutputSpec
	_cmd = "mia-2dstack-cmeans-presegment"

	def _list_outputs(self):
		outputs = self.output_spec().get()
		outputs['out_probmap']=os.path.abspath(self.inputs.out_probmap)
		outputs['out_labels']=os.path.abspath(self.inputs.out_labels)
		outputs['out_flow']=os.path.abspath(self.inputs.out_flow)
		return outputs

#
# Main function used for testing
#
if __name__ == "__main__":
	mia_prog = mia_2dstack_cmeans_presegment()
	print( mia_prog.cmdline)
